<?php
/**
 *  Practicewiki_SupportManager.php
 *
 *  @author     {$author}
 *  @package    Practicewiki
 *  @version    $Id: skel.app_manager.php 387 2006-11-06 14:31:24Z cocoitiban $
 */

/**
 *  Practicewiki_SupportManager
 *  @author     {$author}
 *  @access     public
 *  @package    Practicewiki
 */
class Practicewiki_SupportManager extends Ethna_AppManager
{
    /** @var    object     Ethna_Logger  */
    var $logger;
// ϥϥɥ
// $this->logger =& $this->backend->getLogger();

    /** @var    string    ڡ¸ʥե*/
    var $wiki_data_dir;

    /** @var    mixed     wiki pages info  */
    var $wiki_pages = array();

    /**
     *  Practicewiki_SupportManagerΥ󥹥ȥ饯
     *
     *  @access public
     *  @param  object  Ethna_Backend   &$backend   backend֥
     */
    function Practicewiki_SupportManager(&$backend)
    {
        // ܥ֥Ȥ
        $this->backend =& $backend;
        $this->config =& $backend->getConfig();
        $this->i18n =& $backend->getI18N();
        $this->action_form =& $backend->getActionForm();
        $this->af =& $this->action_form;
        $this->session =& $backend->getSession();

        $db_list = $backend->getDBList();
        if (Ethna::isError($db_list) == false) {
            foreach ($db_list as $elt) {
                $varname = $elt['varname'];
                $this->$varname =& $elt['db'];
            }
        }

//		parent::Ethna_AppManager($backend);
		// ///////////////////////////////////////////////////////////////
		// ξޤǤEthna_AppManagerΥ󥹥ȥ饯ʤΥԡ
		// ʲPracticewiki_SupportManagerȼʬ
		// ///////////////////////////////////////////////////////////////

		$this->wiki_data_dir = $this->config->get('wiki_data_dir');
    }

    /**
     *  եƤ
     *
     *  @access public
     *  @param  string  $filename
     *  @param  string  $dir
     *  @return string
     */
    function get_parts_file($filename, $dir) {
		$filename =  $dir . basename($filename);
		if (file_exists($filename)) {
			$content = file_get_contents($filename);
		} else {
			$content = "";
		}
		return $content;
    }

    /**
     *  ե¸
     *
     *  @access public
     *  @param  string  $filename
     *  @param  string  $content
     *  @param  string  $dir
     */
    function put_parts_file ($filename, $content, $dir)
    {
		$filename = $dir . basename($filename);
		$fp = fopen($filename, "w");
		fwrite($fp, $content);
		fclose($fp);
//		chmod($filename, TMP_FILE_MODE);
		return null;
    }



    /**
     *  ڡ
     *
     *  @access public
     *  @param  string  $id
     *  @return mixed   Practicewiki_Wikipage 󥹥
     */
    function get_wikipage ($id = null)
    {
		$page = new Practicewiki_Wikipage($id, $this->wiki_data_dir);
		return $page;
    }

    /**
     *  ڡΥꥹȤ
     *
     *  @access public
     *  @param  string  $filter̤
     *  @return mixed   Practicewiki_Wikipage 󥹥󥹤Ǥ˻
     */
    function get_wiki_pagelist ($filter = null)
    {
		$index =& $this->load_wiki_contents_meta();
		$rowlist =& $this->_get_wiki_pagelist();
		$pagelist = array();
		foreach ($rowlist as $item) {
			$page = new Practicewiki_Wikipage($item['id'], $this->wiki_data_dir);
			if (preg_match("/^\d{10}/", $item['id'])) $page->set_meta('created_at', $item['id']);
			$page->set_meta('updated_at', $item['mtime']);
			$page->set_meta('title', $index[$item['id']]['title']);
			array_push($pagelist, $page);
		}
		$this->wiki_pages =& $pagelist;
		return $pagelist;
    }

    /**
     *  ե뤫Фƥ᥿ǡ
     *
     *  @access public
     *  @return mixed
     */
    function _get_wiki_pagelist ()
    {
		$direntrys = array();
		$dh = opendir(preg_replace("/\/$/", "", $this->wiki_data_dir));
		if ($dh) {
			while (($file = readdir($dh)) !== false) {
				if ($file == '.' || $file == '..') {
					continue;
				} else if (is_dir($this->wiki_data_dir . $file)) {
					continue;
				} else {
					if (preg_match("/^([a-zA-Z0-9]*)\.txt$/", basename($file), $capture)) {
						$mtime = filemtime($this->wiki_data_dir . $file);
						array_push($direntrys, array('id' => $capture[1], 'mtime' => $mtime, 'filename' => $file));
					}
				}
			}
			closedir($dh);
		}
		return $direntrys;
    }

    /**
     *  ᥿ǡȥƤ
     *
     *  @access public
     *  @return mixed
     */
    function load_wiki_contents_meta ()
    {
		$filename = '_index.txt';
		$content = $this->get_parts_file($filename, $this->wiki_data_dir);
		return unserialize($content);
    }

    /**
     *  ᥿ǡȥ򹹿1ڡʬ
     *
     *  @access public
     *  @param  object  Practicewiki_Wikipage
     */
    function update_wiki_contents_meta ($page)
    {
		$filename = '_index.txt';
		$index = $this->load_wiki_contents_meta();
		$index[$page->id] = 
			array(
				'id' => $page->id,
				'title' => $page->get_meta('title'),
				'auther' => $page->get_meta('auther'),
				'note' => $page->get_meta('note')
			);
		$this->put_parts_file($filename, serialize($index), $this->wiki_data_dir);
    }


    /* Utility */

    /**
     *  Ūѥ
     *
     *  @access public
     *  @return string     HTML
     */
	function static_renderer() {
		$arg_list = func_get_args();
		$arg_list = $arg_list[0];

		// Controller
		$c =& $this->backend->getController();
		$renderer =& $c->getRenderer();
		if (! is_array($arg_list['template_values'])) return false;
		// escape
		if ($arg_list['no_escape']) {
			$elements =& $arg_list['template_values'];
		} else {
			$elements = Ethna_Util::escapeHtml($arg_list['template_values']);
		}
		foreach ($elements as $key => $value) {
			$renderer->setProp($key, $value);
		}
		$content = $renderer->perform(sprintf('%s%s', $this->template_parts_dir, $arg_list['template']), true);
		return $content;
	}

    /**
     *  ǤΥǥ쥯ȥ곬ؤ񤭴롣ƥĤΥץӥ塼
     *
     *  @access public
     *  @param  string  $contents
     *  @param  string  $dir_adj
     *  @return string    HTML
     */
    function dir_adj($contents, $dir_adj = '')
    {
		if ($dir_adj == '../' or $dir_adj == '../../') {
			$contents = mb_ereg_replace(" href=\"", " href=\"" . $dir_adj, $contents, 'm');
			$contents = mb_ereg_replace(" src=\"", " src=\"" . $dir_adj, $contents, 'm');
			$contents = mb_ereg_replace($dir_adj . "http://", "http://", $contents, 'm');
			return $contents;
		} else {
			return $contents;
		}
    }

	/**
	 *	LocationRefreshΰư($urlFullPathǽ񤤤Ƥ)
	 *	δؿƤ֤ȤǽϽλޤ
	 *	
	 *	@access	public
	 *	@param	string	$url	ưURL
	 *	@return	bool	true: false:
	 */
	function move($url , $sec = 0)
	{
		//إå;פʸ󤬤Ĥʤͤ˺
		//URL󥳡ϳƥץꥱ(ݸڤ)
		$url = str_replace("\n", '', $url);
		$url = str_replace("\r", '', $url);
		if($sec <= 0){
			header('location: ' . $url);
		}

		//Smartyǽ褦¤ä礳
		print('<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">');
		print('<html><head>');
		printf('<meta http-equiv="refresh" content="%d;url=%s">',  htmlspecialchars($sec, ENT_QUOTES),  htmlspecialchars($url, ENT_QUOTES));
		print('</head><body></body></html>');
		exit;
	}


	/**
	 *	ե뤬ꤵ줿ǥ쥯ȥʲΥե뤫֤ʥǥ쥯ȥȥСк)
	 *
	 *	@access	public
	 *	@param	string	$securepath	ꤹǥ쥯ȥ
	 *	@param	string	$filename	ե̾
	 */
	function isSecurePath($securepath, $filename)
	{
		$real_securepath = realpath($securepath);
		$real_filename   = realpath($filename);
		if ($real_securepath == false) {
			return false;
		}

		if ($real_filename == false) {
			return false;
		}

		if(strncmp($real_filename, $real_securepath, strlen($real_filename)) !== 0){
			return false;
		}

		return true;
	}
}
?>