<?php
/**
 *  Practicewiki_Wikipage.php
 *
 *  @author     {$author}
 *  @package    Practicewiki
 *  @version    $Id: skel.app_manager.php 387 2006-11-06 14:31:24Z cocoitiban $
 */

/**
 *  Practicewiki_Wikipage
 *
 *  @author     {$author}
 *  @access     public
 *  @package    Practicewiki
 */
class Practicewiki_Wikipage extends Practicewiki_SupportManager
{
    /** @var    string    y[Wid   */
    var $id;

    /** @var    string    {   */
    var $body;

    /** @var    array     y[Wɕt郁^f[^  *
    var $meta;
    /** @var    string    metaVACYor񉻂   */
    var $meta_s;


    /**
     *  Practicewiki_WikipagẽRXgN^
     *
     *  @access public
     *  @param  object  Ethna_Backend   &$backend   backendIuWFNg
     */
    function Practicewiki_Wikipage($id = null, $wiki_data_dir = null)
    {
		$this->wiki_data_dir = $wiki_data_dir;
		// id wȂCreate
		$this->id = $id ? $id : time();
		if ($this->existspage($id)) {
			$this->recall_meta();
		} else {
			$this->create();
		}
    }

    /**
     *  y[W݃`FbN
     *
     *  @access public
     *  @param  object  
     *  @return bool    true:I false:G[
     */
    function existspage ()
    {
		return file_exists($this->wiki_data_dir . $this->id . '.txt');
    }

    /**
     *  ^f[^EXgAYy[W̃^f[^𕜋A
     *
     *  @access public
     *  @param  object  
     *  @return bool    true:I false:G[
     */
    function recall_meta ()
    {
		$index = $this->load_wiki_contents_meta();
		$this->meta = $index[$this->id];

		$filename = $this->id . '.txt';
		$mtime = filemtime($this->wiki_data_dir . $filename);
		$this->set_meta('updated_at', $mtime);
		if (preg_match("/^\d{10}$/", $this->id)) $this->set_meta('created_at', $this->id);

		return true;
    }

    /**
     *  meta̓eVACYor񉻂
     *
     *  @access public
     *  @return string    
     */
    function meta_toa ()
    {
		return print_r($this->meta, 1);
    }

    /**
     *  metaւ̃ANZTigetj
     *
     *  @access public
     *  @param  string  
     *  @return mixed
     */
    function get_meta ($element)
    {
		return $this->meta[$element];
    }

    /**
     *  metaւ̃ANZTisetj
     *
     *  @access public
     *  @param  mixed  
     *  @return null
     */
    function set_meta ($element, $value)
    {
		$this->meta[$element] = $value;
    }

    /**
     *  CX^XAVKy[Wp
     *
     *  @access public
     *  @return null
     */
    function create ()
    {
		//$this->wikitext = "";
		$this->body = "";
		$this->meta = array();
    }

    /**
     *  {ƃ^f[^ꂼXV
     *
     *  @access public
     *  @return bool    true:I false:G[
     */
    function update ()
    {
		$filename = $this->id . '.txt';
		$this->set_meta('updated_at', time());
		$this->put_parts_file($filename, $this->body, $this->wiki_data_dir);
		$this->update_wiki_contents_meta($this);
		return true;
    }

    /**
     *  {ǂݍ
     *
     *  @access public
     *  @return bool    true:I false:G[
     */
    function read ()
    {
		$filename = $this->id . '.txt';
		$content = $this->get_parts_file($filename, $this->wiki_data_dir);
		return $this->body = $content;
    }

    /**
     *  delete
     *
     *  @access public
     *  @return bool    true:I false:G[
     */
    function delete ()
    {
		$filename = $this->wiki_data_dir . $this->id . '.txt';
		unlink($filename);
		$this->update_wiki_contents_meta($this);
    }

}
?>