<?php
/**
 *  Page.php
 *
 *  @author     {$author}
 *  @package    Practicewiki
 *  @version    $Id: skel.action.php 387 2006-11-06 14:31:24Z cocoitiban $
 */

/**
 *  pageեμ
 *
 *  @author     {$author}
 *  @access     public
 *  @package    Practicewiki
 */
class Practicewiki_Form_Page extends Practicewiki_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /**
     *  @access private
     *  @var    array   ե
     */
    var $form = array(
        'op' => array(
            // ե
            'type'          => VAR_TYPE_STRING,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'OP',      // ɽ̾ show update create delete

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => true,            // ɬܥץ(true/false)
            'min'           => 1,            // Ǿ
            'max'           => 8,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        'id' => array(
            // ե
            'type'          => VAR_TYPE_STRING,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'Page Name',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => true,            // ɬܥץ(true/false)
            'min'           => 1,            // Ǿ
            'max'           => 200,            // 
            'regexp'        => "/\w*/",            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        'title' => array(
            // ե
            'type'          => VAR_TYPE_STRING,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'Title',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => false,            // ɬܥץ(true/false)
            'min'           => 1,            // Ǿ
            'max'           => 250,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        'body' => array(
            // ե
            'type'          => VAR_TYPE_STRING,    // ͷ
            'form_type'     => FORM_TYPE_TEXTAREA,  // ե෿
            'name'          => 'Body',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => false,            // ɬܥץ(true/false)
            'min'           => 1,            // Ǿ
            'max'           => 655360,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        'auther' => array(
            // ե
            'type'          => VAR_TYPE_STRING,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'Auther',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => false,            // ɬܥץ(true/false)
            'min'           => 1,            // Ǿ
            'max'           => 200,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
        'note' => array(
            // ե
            'type'          => VAR_TYPE_STRING,    // ͷ
            'form_type'     => FORM_TYPE_TEXT,  // ե෿
            'name'          => 'Note',      // ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
            'required'      => false,            // ɬܥץ(true/false)
            'min'           => 1,            // Ǿ
            'max'           => 200,            // 
            'regexp'        => null,            // ʸ(ɽ)

            // ե륿
            'filter'        => null,            // Ѵե륿ץ
        ),
    );
}

/**
 *  pageμ
 *
 *  @author     {$author}
 *  @access     public
 *  @package    Practicewiki
 */
class Practicewiki_Action_Page extends Practicewiki_ActionClass
{
    /**
     *  ¹ǧڽԤ
     *
     *  @access public
     *  @return string  ̾(nullʤｪλ, falseʤλ)
     */
    function authenticate()
    {
		if (preg_match(SITE_DIR_REGEX, $_SERVER['SCRIPT_NAME'])) {
			return null;
		}
		return false;
    }

    /**
     *  page
     *
     *  @access public
     *  @return string      ̾(ｪλʤnull, λʤfalse)
     */
    function prepare()
    {
		$this->session->set('user', array_key_exists('PHP_AUTH_USER', $_SERVER) ? $_SERVER['PHP_AUTH_USER'] : '_');

		if ($this->af->get('id') == "") {
			return 'list';
		}
		if ($this->af->get('id') == "_newpage") {
			$this->af->set('op', 'create');
			$this->af->set('id', time());
			$this->af->set('title', date("Y-m-d", time()));
		}

		if ($this->af->get('op') == "") {
			$this->af->set('op', 'show');
		}
		if ($this->af->get('op') == "update" and $this->af->get('body') == "") {
			$this->af->set('op', 'delete');
		}

// 		if (! get_cfg_var('mbstring.encoding_translation')) {
// 			$this->af->set('body', mb_convert_encoding($this->af->get('body'), mb_internal_encoding(), "eucjp-ms, UTF-8"));
// 			$this->af->set('auther', mb_convert_encoding($this->af->get('auther'), mb_internal_encoding(), "eucjp-ms, UTF-8"));
// 			$this->af->set('note', mb_convert_encoding($this->af->get('note'), mb_internal_encoding(), "eucjp-ms, UTF-8"));
// 			$this->af->set('title', mb_convert_encoding($this->af->get('title'), mb_internal_encoding(), "eucjp-ms, UTF-8"));
// 		}
		if (get_magic_quotes_gpc()) {
			$this->af->set('body', stripslashes($this->af->get('body')));
			$this->af->set('auther', stripslashes($this->af->get('auther')));
			$this->af->set('note', stripslashes($this->af->get('note')));
			$this->af->set('title', stripslashes($this->af->get('title')));
		}

		if ($this->af->validate() > 0) {
			return 'list';
		}

		return null;
    }

    /**
     *  pageμ
     *
     *  @access public
     *  @return string  ̾
     */
    function perform()
    {
		Ethna_Util::setCsrfID();
		return 'page';
    }
}
?>