<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<script type="text/javascript" src="js/wikiformatter.js"></script>
<link href="css/wiki.css" rel="stylesheet" type="text/css">
<style type="text/css">
{literal}
{/literal}
</style>
<script type="text/javascript">
{literal}
var in_view = 'preview';
function view (tab) {
 document.getElementById('view').innerHTML = 
 document.getElementById(tab).innerHTML;
 document.getElementById(in_view).style.visibility = 'hidden';
 document.getElementById('tabitem' + in_view).style.paddingTop = '5px';
 document.getElementById(tab).style.visibility = 'visible';
 in_view = tab;
 document.getElementById('tabitem' + tab).style.paddingTop = '0px';
}

function href_adj(){
 c = document.getElementById('preview').innerHTML;
 c = c.replace(/ href="/g, ' href="../../');
 c = c.replace(/ src="/g, ' src="../../');
 c = c.replace(/ href="\.\.\/\.\.\/http/g, ' href="http');
 c = c.replace(/ src="\.\.\/\.\.\/http/g, ' src="http');
 document.getElementById('preview').innerHTML = c;
 return false;
}

function update_preview () {
 document.getElementById('preview').innerHTML = document.page_form.body.value;
 view('preview');
}

function wiki2body (mode) {
 /* Wiki.Formatter in JavaScript Kazuho@Cybozu Labs */
 var formatter = new Wiki.Formatter();
 if (mode == 'add') {
  document.page_form.body.value
        += formatter.format(document.page_form.wikitext.value);
 } else {
  document.page_form.body.value
        = formatter.format(document.page_form.wikitext.value);
 }
 view('body');
}
{/literal}
</script>
<title>Wiki :: {$app.meta.title|default:"(no page title)"} [{$app.id}]</title>

{if $app.op == "show" or $app.op == "update"}
{assign var=view value="preview"}
{else}
{assign var=view value="property"}
{/if}
</head>
<body onload="javascript:view('{$view}');">
<div id="site">
<div id="content">
<div id="header">
<h1>{$app.meta.title|default:"（タイトル未設定）"}
<span>[{$app.id}] {$app.op}</span></h1>
<p>LOGIN: {$smarty.session.user|default:"-"}<br>
</p>
</div>
<div id="main">
{* コンテンツ ここから *}

<form action="?" method="post" name="page_form">
<input type="hidden" name="action_page" value="1">
<input type="hidden" name="op" value="update">
<input type="hidden" name="id" value="{$app.id}">
{csrfid}
<p>
{$app.meta.title|default:"（タイトル未設定）"} <input type="submit" name="submit" value="保存"> / 
<a href="?action_list=1">ページ一覧</a>
</p>

<div id="editnavi">
<ul>
<li id="tabitempreview" style="padding-top:5px;"><a href="javascript:view('preview')">閲覧</a></li>
<li id="tabitembody" style="padding-top:5px;"><a href="javascript:view('body')">← 編集</a></li>
<li id="tabitemwikitext" style="padding-top:5px;"><a href="javascript:view('wikitext')">← Wiki記法</a></li>
<li id="tabitemproperty" style="padding-top:5px;"><a href="javascript:view('property')">プロパティ</a></li>
<li id="tabitemhelp" style="padding-top:5px;"><a href="javascript:view('help')">ヘルプ</a></li>
</ul>
</div>

<div id="preview" title="プレビュー">
{$app_ne.body}
</div>

<div id="body">
<h3>HTML形式で編集中...</h3>
<p>
<textarea name="body" cols="80" rows="20">
{$app_ne.body}
</textarea><br>
<input type="button" name="updatepreview" value="プレビューを更新する" onclick="update_preview();">
</p>
</div>

<div id="wikitext">
<h3>Wiki形式で編集中...</h3>
<p>
<textarea name="wikitext" cols="80" rows="20">
{$app.wikitext}
</textarea><br>
<input type="button" name="wiki2page" value="置き換える" onclick="wiki2body('replace');"> 
<input type="button" name="wiki2page" value="最後に挿入" onclick="wiki2body('add');"> 
</p>
</div>

<div id="property">
<h3>タイトル</h3>
<p><input type="text" name="title" value="{$app.meta.title}"> </p>
<h3>id</h3>
<p>[{$app.id}]</p>
<h3>作成日時</h3>
<p>{$app.meta.created_at|date_format:"%Y-%m-%d %X"|default:"-"}</p>
<h3>更新日時</h3>
<p>{$app.meta.updated_at|date_format:"%Y-%m-%d %X"|default:"-"}</p>
<h3>作成・編集者</h3>
<p><input type="text" name="auther" value="{if $smarty.session.user}{$smarty.session.user}{else}{$app.meta.auther}{/if}"> </p>
<h3>備考</h3>
<p><input type="text" name="note" value="{$app.meta.note}" size="110"> </p>
<h3>編集前のソース</h3>
<pre>
{$app_ne.body|escape:"html"}
</pre>
</div>

<div id="help">
<pre>
*大見出し
**中見出し
***小見出し

!大見出し
!!中見出し
!!!小見出し

-リスト
--リスト
---リスト

+番号順リスト
++番号順リスト
+++番号順リスト

空行から次の空行までの間の文章のまとまりが、ひとつの段落になります。
段落の中では行が継続されます。
~~←を使うと強制改行になります。

 行頭にスペースかタブ文字があると、
 そのブロック（連続する行）が整形済みテキストになります。

>複数行の
>引用文

リンクの書き方
URLはそのままリンクになります。
http://example.net/
テキストをリンクにする時
[some web site|http://example.net/]

文章の中で''強調したい部分''や、'''斜体'''、__下付き__の書き方など
%%取消し%%
%%%追記%%%
文に注釈((これが注釈文))をつける

:定義リスト|内容

表
|セル|セル|セル
,セル,セル,セル
,セル,セル,セル

----
区切りのヨコ線

</pre>
</div>

</form>

<div id="view">
</div>

{* コンテンツ ここまで *}
</div>
<div id="footer">
<address>
practicewiki 
Powered By Ethna.
</address>
</div>
</div>
</div>
</body>
</html>
